Attribute VB_Name = "MainModule"
' SendToVim, version 1.0

' Author: Christian Schaller (sca@isogmbh.de)

' Description: sends given arguments (with or without ")
' to Vim (if exists, otherwise Vim is started at first), to have only one
' instance of Vim running.

' Requires: GVim 5.3 with OLE support

' Examples:
' edit MyFile with vim:
'   SendToVim :e MyFile
' open new window with MyFile and maximize it:
' SendToVim ":split MyFile | resize"
' tell vim to insert contents of register a
'   SendToVim "\"ap"
' search for "set" and highlight it
'   SendToVim "/set<c-m>:se hls"

Sub Main()
    Dim usage As String
    Dim length As Integer
    Dim commandline As Variant
    Dim path As String
    
    usage = "SendToVim 1.0 (19. III. 99)" _
        & vbCrLf _
        & vbCrLf & "Usage: SendToVim <vim command>"
        
    'get command line
    commandline = Command()
    length = Len(commandline)
    
    'get current path
    path = CurDir()
    
    'no arguments?
    If length = 0 Then
        MsgBox usage
        Exit Sub
    End If
    
    'check for leading "
    If Left(commandline, 1) = Chr(34) Then
        'if so, remove the last charakter (")
        commandline = Mid(commandline, 2, length - 2)
    End If
    
    Dim vim As Object
    Set vim = CreateObject("Vim.Application")
    vim.SendKeys (":cd " & path & "<c-m>")
    vim.SendKeys (commandline & "<c-m>")
    vim.SetForeground
End Sub
